#ifndef DINPUTDEVICEINC
#define DINPUTDEVICEINC

#include <string>
#include "dinput.h"

// data usually is reported
// axes, slider, povs, buttons

#define BUFFERSIZE	40

class DInputDevice : public gs_InputDevice
{
public:
	DInputDevice(IDirectInputDevice8* device, DInputManager* manager);
	~DInputDevice();

	string GetType() { return Type; }

	// this returns input but does not update
	// the pointer it returns should be valid throughout
	// the life of the device
	gs_InputData& GetInput();	
	void Update();	// this updates the input
	
	void SetAxisMode( AxisStates state );
	
	int GetIndex( string name );
	string GetName( int index);

	int GetTotalAxes() { return Axes; }
	int GetTotalButtons() { return States; }
	int GetTotalPOVs() { return POVs; }

	
	void Set(int index, int pos) { }// REMEMBER UNIMPLEMENTED
	void SetInputBuffer(int size);
	int AddNotify( gs_InputListener* b);
	int RemoveNotify( gs_InputListener* b);

		
	// private to all but file scope (enumeration function needs)
	void AddItem(LPCDIDEVICEOBJECTINSTANCE obj);	// adds device axes, keys, etc
	int CheckName( char* name );

private:
	gs_InputListener* Listener;

	void SetFormat();
	void SetShortCuts();	// this sets up the programmer shortcuts (ie MOUSEX, MOUSEY, etc)

	gs_InputData ReturnData;
	string Type;
	IDirectInputDevice8* Device;
	DInputManager* Manager;

	char* Data;
	int* ValueData;
	unsigned char* StateData;
	int DataSize;
	int Values; // any ranges (axes, povs, sliders)
	int States;	// off/on devices(keyboard keys, mouse buttons)

	int Axes;
	int POVs;

	// temporary variable that need to be global to the object
	string toCheck;
	int Found;
	int Enumerated;
	int CheckMode;
};

#endif