#include <string>
using namespace std;

#include "dinput.h"
#include "core.h"
#include "ddevice.h"

#include "mmgr.h"

#define SafeRelease(r) if(r) { r->Release(); }

// enumeration function
BOOL CALLBACK DIEnumCallback(LPCDIDEVICEINSTANCE lpddi, LPVOID pvRef) 
{
	DInputManager* d = (DInputManager*)pvRef;
	IDirectInputDevice8* device;

	d->DInput8->CreateDevice(lpddi->guidInstance, &device, 0);
	if (device)
		d->AddDevice( new DInputDevice( device, d));

	return DIENUM_CONTINUE; // or DIENUM_STOP
}

DInputManager::DInputManager()
{

	// initialize direct input
	// and enumerate all devices
	int error = DirectInput8Create( GethInstance(), // HINSTANCE
						DIRECTINPUT_VERSION, // Verstion
						IID_IDirectInput8A, // ANSI version ( replace a with w for unicode)
						(void**)&DInput8,  
						0); // COM Agregation

	if (!DInput8)
		return;

	DInput8->EnumDevices(0, // all device types
						DIEnumCallback,// which callback
						this, // optional value to pass to callback
						DIEDFL_ATTACHEDONLY); // why would I want to enumerate unattached devices?
}

DInputManager::~DInputManager()
{
	SafeRelease(DInput8);

	for (int x = 0; x < Devices.size(); x++)
		delete Devices[x];

}

// retrieves individual devices
// such as mouse, keyboard, or joystick
int DInputManager::GetTotal()
{
	return Devices.size();
}

gs_InputDevice* DInputManager::Get(int x)
{
	return Devices[x];
}

gs_InputDevice* DInputManager::Get( char* name)
{
	for (int x = 0; x < Devices.size(); x++)
	{
		if (Devices[x]->GetType().find(name) != -1)
			return Devices[x];
	}
	return 0;
}

// pointers provide a way to bind to a specific data item
// isValid is a way of checking if that pointer is still valid
int DInputManager::isValid( gs_InputDevice* ref)
{
	// REMEMBER TO FILL
	return 1;
}

void DInputManager::AddDevice( gs_InputDevice* device)
{
	Devices.push_back(device);
}
